program WAVconvert;
{ convert nonstandard IMA ADPCM WAV file from Siemens phone }

uses WAVhdr,support;


var ls:LoadStatus;
    f,fo:file;
    Info:PCMWaveFormat;
    res:word;
    pos:longint;
    buf:array[1..512] of byte;
    siz:longint;   { global }

procedure adpcm_decode;
const StepTab:array[0..88] of integer = (
                    7,     8,     9,    10,    11,    12,    13,    14,
                   16,    17,    19,    21,    23,    25,    28,    31,
                   34,    37,    41,    45,    50,    55,    60,    66,
                   73,    80,    88,    97,   107,   118,   130,   143,
                  157,   173,   190,   209,   230,   253,   279,   307,
                  337,   371,   408,   449,   494,   544,   598,   658,
                  724,   796,   876,   963,  1060,  1166,  1282,  1411,
                 1552,  1707,  1878,  2066,  2272,  2499,  2749,  3024,
                 3327,  3660,  4026,  4428,  4871,  5358,  5894,  6484,
                 7132,  7845,  8630,  9493, 10442, 11487, 12635, 13899,
                15289, 16818, 18500, 20350, 22385, 24623, 27086, 29794,
                32767 );

const IndexTab:array[0..15] of integer = ( -1, -1, -1, -1, 2, 4, 6, 8,
                               -1, -1, -1, -1, 2, 4, 6, 8 );

type word32=array[0..3] of byte;

var cur:word32; bufptr:byte; { globals }
    smp:word absolute cur;
    prevsamp,samp:longint; diffsamp:byte;
    ndx,diff:integer;


procedure getsample(var s:byte);
begin
if bufptr=8 then bufptr:=0;
if bufptr=0 then BlockRead(f,cur,4);
if odd(bufptr) then s:=(cur[bufptr div 2] and $F0) shr 4
               else s:=cur[bufptr div 2] and $0F;
inc(bufptr);
end;

procedure outsample(samp:longint);
var s:integer; res:word;
begin
s:=samp;
BlockWrite(fo,s,2,res);
if res<>2 then abort('Error writing output file');
siz:=siz+2;
end;


begin
BlockRead(f,cur,4); samp:=smp; ndx:=cur[2];
outsample(samp); prevsamp:=samp;
bufptr:=0;
while not (eof(f) and (bufptr=8)) do
  begin
  getsample(diffsamp);
  diff:=0;
  if diffsamp and 4<>0 then diff:=diff+StepTab[ndx];
  if diffsamp and 2<>0 then diff:=diff+(StepTab[ndx] shr 1);
  if diffsamp and 1<>0 then diff:=diff+(StepTab[ndx] shr 2);
  diff:=diff+(StepTab[ndx] shr 3);
  if diffsamp and 8<>0 then diff:=-diff;
  samp:=prevsamp+diff;
  if samp>32767 then samp:=32767;
  if samp<-32768 then samp:=-32768;
  outsample(samp);
  ndx:=ndx+IndexTab[diffsamp];
  if ndx>88 then ndx:=88;
  if ndx<0 then ndx:=0;
  prevsamp:=samp;
  end;
end;


begin
if paramcount<2 then abort('Usage: '+GetMyName+' input.wav output.wav');
ls:=LoadSample(f,paramstr(1),Info);
case ls of
  LS_LoadError: abort('Can''t open input file');
  LS_InvFormat: abort('Input file not a WAV file');
  LS_OK: with Info do
     if (wFormatTag<>17) or (nChannels<>1) or (nSamplesPerSec<>8000) or
        (wBitsPerSample<>4) or (nAvgBytesPerSec<>0) or (nBlockAlign<>0) then
        abort('Input file doesn''t have proper format')
     else
        begin
        pos:=FmtChunkPos-4;
        if pos>SizeOf(buf) then abort('Too long header chunk in input file');
        assign(fo,paramstr(2)); {$I-} rewrite(fo,1); {$I+}
        if ioresult<>0 then abort('Can''t open output file');
        Seek(f,0); BlockRead(f,buf,pos);
        BlockWrite(fo,buf,pos,res);
        if res<>pos then abort('Error writing output file');
        BlockRead(f,siz,4); siz:=siz-4;
        BlockWrite(fo,siz,4,res);
        if res<>4 then abort('Error writing output file');
        wFormatTag:=1; wBitsPerSample:=16; nAvgBytesPerSec:=2*nSamplesPerSec; nBlockAlign:=2;
        BlockWrite(fo,Info,SizeOf(Info),res);
        if res<>SizeOf(Info) then abort('Error writing output file');
        Seek(f,FmtChunkPos+FmtChunkSize);
        pos:=DataChunkPos-4-FilePos(f);
        if pos>SizeOf(buf) then abort('Too long header chunk in input file');
        BlockRead(f,buf,pos); BlockWrite(fo,buf,pos,res);
        if res<>pos then abort('Error writing output file');
        pos:=FilePos(fo);
        siz:=0;
        BlockWrite(fo,siz,4,res);
        if res<>4 then abort('Error writing output file');
        Seek(f,DataChunkPos);
        adpcm_decode;
        Seek(fo,pos); BlockWrite(fo,siz,4,res);
        if res<>4 then abort('Error writing output file');
        close(fo); close(f);
        end;
end;
end.
