unit WAVhdr;

interface

uses Dos;
type LoadStatus=( LS_OK,         { odczyt poprawny }
                  LS_LoadError,  { blad dyskowy }
                  LS_InvFormat );{ nie plik .WAV }

     PCMWaveFormat=record
                      wFormatTag, nChannels:word;
                      nSamplesPerSec, nAvgBytesPerSec:longint;
                      nBlockAlign, wBitsPerSample:word;
                   end;

     ChunkName=array[1..4] of char;

var FmtChunkPos,FmtChunkSize,DataChunkPos:longint;


function LoadSample (var f:file; Name:string; var Info:PCMWaveFormat):LoadStatus;


implementation

function LoadSample (var f:file; Name:string; var Info:PCMWaveFormat):LoadStatus;
var res:word;
    i:word; pos:longint;
    WAVHeader:record
                 Riff:ChunkName;
                 Size:longint;
                 Wave:ChunkName;
              end;
    WAVChunk:record
                Name:ChunkName;
                Size:longint;
             end;

   function FindChunk (Name:ChunkName):boolean;
   var Done:boolean;
   begin
   Done:=false;
   repeat
      BlockRead(f,WAVChunk,SizeOf(WAVChunk));
{      writeln('found chunk ''',WAVChunk.Name,''' size=',WAVChunk.Size);   }
      if WAVChunk.Name=Name then Done:=true
      else
         begin
         if Odd(WAVChunk.Size) then inc(WAVChunk.Size);
         seek(f,FilePos(f)+WAVChunk.Size);
         end;
   until Done or eof(f);
   FindChunk:=Done;
   end;

begin
assign(f,Name);
{$I-}
reset(f,1);
if IOResult<>0 then
{$I+}
   begin
   LoadSample:=LS_LoadError; exit
   end;
BlockRead(f,WAVHeader,SizeOf(WAVHeader));
with WAVHeader do
   if (Riff<>'RIFF') or (Wave<>'WAVE') then
      begin
      close(f); LoadSample:=LS_InvFormat; exit;
      end;
if not FindChunk('fmt ') then
   begin
   close(f); LoadSample:=LS_InvFormat; exit;
   end;
FmtChunkPos:=FilePos(f);
FmtChunkSize:=WAVChunk.Size;
BlockRead(f,Info,SizeOf(Info));
Seek(f,FmtChunkPos+FmtChunkSize);
if not FindChunk('data') then
   begin
   close(f); LoadSample:=LS_InvFormat; exit
   end;
DataChunkPos:=FilePos(f);
LoadSample:=LS_OK;
end;

end.
